/*Behold... baby's second LUA spaghetti code! Fear its overcomplicated recipe!
What's that? Where's the first? Check back in 2025, maybe
~~~~~
this entire lua script is for the jetpack/scuba gear, unlocked when the player
manages to get all 7 chaos emeralds, and how crash interacts with other players*/

local function JetpackFumes(player)
	if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
		P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_MEDIUMBUBBLE)
	else
		P_SpawnThokMobj(player)
	end
	P_SpawnSkidDust(player, 25 * FRACUNIT)
end
local EquipFrames = {
	[S_PLAY_SUPER_TRANS1] = true,
	[S_PLAY_SUPER_TRANS2] = true,
	[S_PLAY_SUPER_TRANS3] = true,
	[S_PLAY_SUPER_TRANS4] = true,
	[S_PLAY_SUPER_TRANS5] = true,
	[S_PLAY_SUPER_TRANS6] = true
}
local function ScubaJetpack(player)
	if not CrashSkinCheck(player)
		return
	end
	
	if All7Emeralds(player.powers[pw_emeralds]) or All7Emeralds(emeralds)
		/*this allows the player to equip/unequip the jetpack if they press
		custom 2 and have any amount of rings at all while on the ground*/
		if player.jetpackmode == nil
			player.jetpackmode = false
		end
		if player.pressequip == nil
			player.pressequip = false
		end
		if input.gameControlDown(GC_CUSTOM2) and player.rings > 0 and
				P_IsObjectOnGround(player.mo)
			if not player.pressequip
				if player.jetpackmode
					player.mo.eflags = $ & ~MFE_FORCESUPER
					player.jetpackmode = false
				else
					player.mo.state = S_PLAY_SUPER_TRANS1
					player.mo.eflags = $ | MFE_FORCESUPER
					player.jetpackmode = true
				end
				player.pressequip = true
			end
		else
			player.pressequip = false
		end
	end
	if player.mo.eflags & MFE_FORCESUPER and not EquipFrames[player.mo.state]
		//this allows the player to do the spin while in jetpack mode
		CrashTornadoSpin(player)
		//this handles the different sprites displayed
		if not P_IsObjectOnGround(player.mo)
			local wiggle = 1 * FRACUNIT / 2
			if (player.mo.momx <= wiggle and player.mo.momx >= wiggle * -1) and 
					(player.mo.momy <= wiggle and player.mo.momy >= wiggle * -1)
				if not (player.mo.state == S_PLAY_FLOAT or player.mo.state ==
						S_PLAY_SWIM or player.mo.state == S_PLAY_CLING)
					player.mo.state = S_PLAY_FLOAT
				end
			else
				if not (player.mo.state == S_PLAY_RUN or player.mo.state ==
						S_PLAY_SWIM or player.mo.state == S_PLAY_CLING)
					player.mo.state = S_PLAY_RUN
				end
			end
		end
		//this is the ring drain mechanic
		if player.draintimer == nil
			player.draintimer = 1 * TICRATE
		end
		if player.draintimer <= 0
			player.rings = $ - 1
			player.draintimer = 1 * TICRATE
		end
		//this allows the player to breathe underwater and switch to scuba gear
		if player.mo.eflags & MFE_UNDERWATER or player.mo.eflags & MFE_GOOWATER
			player.powers[pw_underwater] = 30 * TICRATE
			if not (player.mo.state == S_PLAY_SWIM or player.mo.state == 
					S_PLAY_CLING)
				player.mo.state = S_PLAY_SWIM
			end
			player.draintimer = $ - 1
		elseif player.mo.state == S_PLAY_SWIM
			player.mo.state = S_PLAY_FLOAT
		end
		//this handles the jetpack/scuba ascent/descent
		if input.gameControlDown(GC_JUMP) and player.pflags & PF_JUMPED and not
				(player.pflags & PF_STARTJUMP)
			JetpackFumes(player)
			CrashJumpManager(player.mo, 7 * FRACUNIT)
			player.draintimer = $ - 3
		elseif input.gameControlDown(GC_SPIN) and not P_IsObjectOnGround(player.mo)
			JetpackFumes(player)
			if (player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz > 0) or
					(not (player.mo.eflags & MFE_VERTICALFLIP) and 
					player.mo.momz < 0)
				CrashJumpManager(player.mo, -2 * FRACUNIT)
			end
			player.draintimer = $ - 1
		end
		//this forces the player out of jetpack mode if they ran out of rings
		if player.rings <= 0
			player.mo.eflags = $ & ~MFE_FORCESUPER
			player.mo.state = S_PLAY_FALL
			player.jetpackmode = false
		end
	end
end
addHook("PlayerThink", ScubaJetpack)

/*this makes it so the player can't grab air bubbles while in scuba gear, since
they don't need it*/
local function NoBubbles(special, toucher)
	if toucher.skin == "bandicoot" and toucher.eflags & MFE_FORCESUPER
		return true
	end
end
addHook("TouchSpecial", NoBubbles, MT_EXTRALARGEBUBBLE)

//this knocks other players back if the crash player spins into them
local function TornadoKnockback(thing, tmthing)
	if tmthing.skin == "bandicoot" and tmthing.state == S_PLAY_CLING
		if tmthing.z >= thing.z - thing.height and tmthing.z <= thing.z + 
				thing.height
			P_DoPlayerPain(thing.player)
			thing.player.powers[pw_flashing] = 0
		end
	end
end
addHook("MobjCollide", TornadoKnockback, MT_PLAYER)