/*Behold... baby's second LUA spaghetti code! Fear its overcomplicated recipe!
What's that? Where's the first? Check back in 2025, maybe
~~~~~
this entire lua script is dedicated to crash's health system and deaths as well 
as aku aku's object data and turning monitors into crates*/

freeslot("MT_AKUAKU", "S_AKU_STND", "S_CRATE_RING", "S_CRATE_MAGNET", 
		"S_CRATE_FORCE", "S_CRATE_NUKE", "S_CRATE_WIND", "S_CRATE_ELEMENT", 
		"S_CRATE_SHOES", "S_CRATE_INVIN", "S_CRATE_1UP", "S_CRATE_NTRO", 
		"S_CRATE_FLAME", "S_CRATE_BUBBLE", "S_CRATE_THUNDER", "SPR_AKUS", 
		"SPR_CRRG", "SPR_CRMG", "SPR_CRFC", "SPR_CRNK", "SPR_CRWD", "SPR_CREL", 
		"SPR_CRSP", "SPR_CRIN", "SPR_CRLF", "SPR_CRNO", "SPR_CRFR", "SPR_CRBB", 
		"SPR_CRTH")
states[S_AKU_STND] = {
	sprite = SPR_AKUS,
	frame = A,
	tics = 1,
	nextstate = S_AKU_STND,
	action = A_Custom3DRotate
}
mobjinfo[MT_AKUAKU] = {
	spawnstate = S_AKU_STND,
	spawnhealth = 1,
	seestate = S_AKU_STND,
	speed = 25,
	radius = 10*FRACUNIT,
	height = 32*FRACUNIT,
	flags = MF_FLOAT|MF_NOCLIP
}
states[S_CRATE_RING] = {
	sprite = SPR_CRRG,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_RING
}
states[S_CRATE_MAGNET] = {
	sprite = SPR_CRMG,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_MAGNET
}
states[S_CRATE_FORCE] = {
	sprite = SPR_CRFC,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_FORCE
}
states[S_CRATE_NUKE] = {
	sprite = SPR_CRNK,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_NUKE
}
states[S_CRATE_WIND] = {
	sprite = SPR_CRWD,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_WIND
}
states[S_CRATE_ELEMENT] = {
	sprite = SPR_CREL,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_ELEMENT
}
states[S_CRATE_SHOES] = {
	sprite = SPR_CRSP,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_SHOES
}
states[S_CRATE_INVIN] = {
	sprite = SPR_CRIN,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_INVIN
}
function A_1upCrateThinker(actor, var1, var2)
	A_1upThinker(actor, var1, var2)
	actor.sprite = SPR_CRLF
end
states[S_CRATE_1UP] = {
	sprite = SPR_CRLF,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_1UP,
	action = A_1upCrateThinker
}
states[S_CRATE_NTRO] = {
	sprite = SPR_CRNO,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_NTRO
}
states[S_CRATE_FLAME] = {
	sprite = SPR_CRFR,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_FLAME
}
states[S_CRATE_BUBBLE] = {
	sprite = SPR_CRBB,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_BUBBLE
}
states[S_CRATE_THUNDER] = {
	sprite = SPR_CRTH,
	frame = A,
	tics = 1,
	nextstate = S_CRATE_THUNDER
}

local function Aku0Dead(player)
	if player.akuaku and player.akuaku.valid
		P_KillMobj(player.akuaku)
	end
end
local function Aku1Spawn(player)
	if player.akuaku == nil or not player.akuaku.valid
		player.akuaku = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_AKUAKU)
		player.akuaku.target = player.mo
		player.akuaku.shadowscale = 2 * FRACUNIT / 3
	elseif player.akulevel <= 1
		player.akuaku.colorized = false
	end
	if player.mo.eflags & MFE_VERTICALFLIP
		player.akuaku.eflags = $ | MFE_VERTICALFLIP
	else
		player.akuaku.eflags = $ & ~MFE_VERTICALFLIP
	end
end
local function Aku2Upgrade(player)
	Aku1Spawn(player)
	if not player.akuaku.colorized
		player.akuaku.colorized = true
		player.akuaku.color = SKINCOLOR_ORANGE
	end
end
local function Aku3Invincible(player)
	if not player.powers[pw_invulnerability]
		player.powers[pw_invulnerability] = 20 * TICRATE
		player.akulevel = $ - 2
	end
end
local AkuLevels = {
	[0] = Aku0Dead,
	[1] = Aku1Spawn,
	[2] = Aku2Upgrade,
	[3] = Aku3Invincible
}

/*this determines what happens when the player gets a shield or invincibility
which effects aku aku*/
local function AkuAkuLevel(player)
	if not CrashSkinCheck(player) or player.powers[pw_carry] == CR_NIGHTSMODE
		if player.akuaku and player.akuaku.valid
			if player.akuaku.invin
				player.powers[pw_invulnerability] = 0
			end
			P_KillMobj(player.akuaku)
		end
		return
	end
	
	if player.akulevel == nil
		player.akulevel = 0
	end
	if player.powers[pw_shield]
		if not (player.powers[pw_invulnerability] or player.powers[pw_shield] ==
				SH_PINK)
			player.akulevel = $ + 1
		end
		player.powers[pw_shield] = SH_NONE
	end
	if player.powers[pw_invulnerability]
		if player.akuaku == nil or not player.akuaku.valid
			player.akuaku = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_AKUAKU)
			player.akuaku.target = player.mo
			player.akuaku.shadowscale = 2 * FRACUNIT / 3
		end
		if not player.akuaku.colorized
			player.akuaku.colorized = true
			player.akuaku.color = SKINCOLOR_ORANGE
		end
		local akuakuheight = player.mo.z
		if player.mo.eflags & MFE_VERTICALFLIP
			akuakuheight = player.mo.z - player.height - 10 * FRACUNIT
		else
			akuakuheight = player.mo.z + player.height + 10 * FRACUNIT
		end
		player.akuaku.invin = true
		P_MoveOrigin(player.akuaku, player.mo.x, player.mo.y, akuakuheight)
		player.akuaku.angle = player.mo.angle
	else
		AkuLevels[player.akulevel](player)
		if player.akuaku and player.akuaku.valid
			player.akuaku.invin = false
		end
	end
end
addHook("PlayerThink", AkuAkuLevel)

/*modifying the function to define the values for aku aku's rotation around the
player*/
function A_Custom3DRotate(actor, var1, var2)
	//var1(placement) = (vertical offset << 16) + radius
	//var2(rotation) = (horizontal speed << 16) + vertical speed
	if actor.type == MT_AKUAKU
		if actor.invin
			A_ForceStop(actor, 0)
		else
			if actor.eflags & MFE_VERTICALFLIP
				var1 = (-25 << 16) + 40
			else
				var1 = (25 << 16) + 40
			end
			var2 = (60 << 16) + 0
		end
	end
	super(actor, var1, var2)
end

//this determines what happens if the player gets hit
local function HealthPoints(target, inflictor, source, damage, damagetype)
	if target.validcrate
		P_KillMobj(target)
		return
	end
	if target.skin != "bandicoot" or target.player.powers[pw_carry] ==
			CR_NIGHTSMODE
		return
	end
	
	if target.player.akulevel == 0
		P_KillMobj(target, inflictor, source, damagetype)
	else
		target.player.akulevel = $ - 1
		P_DoPlayerPain(target.player, source, inflictor)
	end
	return true
end
addHook("MobjDamage", HealthPoints)

//table and function checks if a mapthing's type is a valid monitor for reskins
local MonitorType = {
	//10 rings
	[400] = true,
	//attraction shield
	[402] = true,
	//force shield
	[403] = true,
	//armageddon shield
	[404] = true,
	//whirlwind shield
	[405] = true,
	//elemental shield
	[406] = true,
	//super sneakers
	[407] = true,
	//invincibility
	[408] = true,
	//extra life
	[409] = true,
	//eggman monitor
	[410] = true,
	//flame shield
	[420] = true,
	//bubble shield
	[421] = true,
	//lightning shield
	[422] = true
}
local function MonitorCounter(mo, mapthing)
	if G_GametypeUsesLives() and not G_CompetitionGametype()
		if MonitorType[mapthing.type]
			mo.validcrate = true
			mo.isnotbroken = true
		end
	end
end
addHook("MapThingSpawn", MonitorCounter)

//this reskins all valid monitors into crates
local MonitorTransform = {
	[MT_RING_BOX] = S_CRATE_RING,
	[MT_ATTRACT_BOX] = S_CRATE_MAGNET,
	[MT_FORCE_BOX] = S_CRATE_FORCE,
	[MT_ARMAGEDDON_BOX] = S_CRATE_NUKE,
	[MT_WHIRLWIND_BOX] = S_CRATE_WIND,
	[MT_ELEMENTAL_BOX] = S_CRATE_ELEMENT,
	[MT_SNEAKERS_BOX] = S_CRATE_SHOES,
	[MT_INVULN_BOX] = S_CRATE_INVIN,
	[MT_1UP_BOX] = S_CRATE_1UP,
	[MT_EGGMAN_BOX] = S_CRATE_NTRO,
	[MT_FLAMEAURA_BOX] = S_CRATE_FLAME,
	[MT_BUBBLEWRAP_BOX] = S_CRATE_BUBBLE,
	[MT_THUNDERCOIN_BOX] = S_CRATE_THUNDER
}
local function MonitorToCrate(mo)
	if mo.validcrate
		if mo.isnotbroken and mo.valid
			mo.state = MonitorTransform[mo.type]
			if mo.type == MT_EGGMAN_BOX
				local willhop = P_RandomKey(100)
				if willhop == 5
					CrashJumpManager(mo, 5 * FRACUNIT)
				end
			end
		else
			mo.state = S_NULL
		end
	end
end
addHook("MobjThinker", MonitorToCrate)

//this handles what happens to the nitro crates when touched
local function NitroNoTouch(thing, tmthing)
	if tmthing.type == MT_PLAYER and thing.validcrate
		if tmthing.z >= thing.z - thing.height and tmthing.z <= thing.z + 
				thing.height
			P_KillMobj(thing)
		end
	end
end
addHook("MobjCollide", NitroNoTouch, MT_EGGMAN_BOX)

//this handles what happens if a crate got destroyed (more specifically nitro)
local function MonitorBreak(target, inflictor, source, damagetype)
	if target.validcrate
		if target.type == MT_EGGMAN_BOX
			local nitroexplode = P_SpawnMobjFromMobj(target, 0, 0, 0, 
					MT_TNTBARREL)
			nitroexplode.colorized = true
			nitroexplode.color = SKINCOLOR_GREEN
			P_KillMobj(nitroexplode)
		end
		target.isnotbroken = false
	elseif target.skin == "bandicoot"
		target.player.akulevel = 0
	end
end
addHook("MobjDeath", MonitorBreak)